// file      : cstring-traits.hxx
// copyright : xxt
// license   : xxt

#ifndef ODB_MFC_CSTRING_SQLITE_CSTRING_TRAITS_HXX
#define ODB_MFC_CSTRING_SQLITE_CSTRING_TRAITS_HXX

#include <odb/pre.hxx>

#include <cstring> // std::memcpy
#include <cstddef> // std::size_t

#include <stdafx.h>//CString

#include <odb/details/buffer.hxx>
#include <odb/sqlite/traits.hxx>

namespace odb
{
  namespace sqlite
  {
    template <>
	struct image_traits<CString, id_text>
    {//Ƕͱ
      typedef details::buffer image_type;

      // Use UTF-8 binding for CString.
      //
      static const bind::buffer_type bind_value = bind::text;
    };

    template <>
	struct default_value_traits <CString, id_text>
    {
    public:
      typedef CString value_type;
	  typedef CString query_type;
      typedef details::buffer image_type;

      static void
      set_value (CString& v,
                 const details::buffer& b,
                 std::size_t n,//תֽ
                 bool is_null)
      {//image-->CString
        if (is_null)
		{
			v = CString();
		}
        else
		{
			char* ch = NULL;
			ch = (char*)malloc(sizeof(char) * n);//chС
			std::memcpy(ch, b.data(), n);
			v.Format(_T("%s"), ch);
		}
      }

      static void
      set_image (details::buffer& b,
                 std::size_t& n,
                 bool& is_null,
				 const CString& v)
      {//CString-->image
        if (v.IsEmpty())
          is_null = true;
        else
        {
          is_null = false;
		  const char* ch = (LPCTSTR)v;//CStringתchar*
		  n = strlen(ch) + 1;//ֽ'\0'
		  //n = v.GetLength() * sizeof(TCHAR);//ֽ
		  //n = CStringA(v).GetLength();ֽ
          if (n > b.capacity ())
            b.capacity (n);
          std::memcpy (b.data (), ch, n);
        }
      }
    };

    template <>
    struct default_type_traits<CString>
    {
      static const database_type_id db_type_id = id_text;
    };
  }
}

#include <odb/post.hxx>

#endif // ODB_MFC_CSTRING_SQLITE_CSTRING_TRAITS_HXX
