// file      : odb/mfc/version.hxx
// copyright : XXT
// license   : XXT

#ifndef ODB_MFC_VERSION_HXX
#define ODB_MFC_VERSION_HXX

#include <odb/pre.hxx>

#include <odb/version.hxx>

// Version format is AABBCCDD where
//
// AA - major version number
// BB - minor version number
// CC - bugfix version number
// DD - alpha / beta (DD + 50) version number
//
// When DD is not 00, 1 is subtracted from AABBCC. For example:
//
// Version     AABBCCDD
// 2.0.0       02000000
// 2.1.0       02010000
// 2.1.1       02010100
// 2.2.0.a1    02019901
// 3.0.0.b2    02999952
//

// Check that we have compatible ODB version.
//
#if ODB_VERSION != 20400
#  error incompatible odb interface version detected
#endif

// ODB MFC interface version: odb interface version plus the MFC interface
// version.
//
#define ODB_MFC_VERSION     2040000
#define ODB_MFC_VERSION_STR "2.4.0"

// libodb-mfc version: odb interface version plus the bugfix version. Note
// that LIBODB_MFC_VERSION is always greater or equal to ODB_MFC_VERSION
// since if the MFC interface virsion is incremented then the bugfix version
// must be incremented as well.
//
#define LIBODB_MFC_VERSION     2040000
#define LIBODB_MFC_VERSION_STR "2.4.0"

#include <odb/post.hxx>

#endif // ODB_MFC_VERSION_HXX
